#include <bits/stdc++.h>
#define ff first
#define ss second
using namespace std;
pair<string, int>niz[100000];
int n, o, a, b, ab, niz2[10], p;
int main(){
    cin >> n >> o >> a >> b >> ab;
    for(int i=1; i<=n; i++){
        cin >> niz[i].ff >> niz[i].ss;
    }
    for(int i=1; i<=n; i++){                        //coek
        if(niz[i].ff=="O"){
            o-=niz[i].ss;
            niz2[0]+=niz[i].ss;
        }
        if(niz[i].ff=="A"){
            a-=niz[i].ss;
            niz2[1]+=niz[i].ss;
            if(a<0){
                a=0;
                p=niz[i].ss-a;
                o-=p;
                if(o<0){cout << "nemoguce"; break;}
            }

        }
        cout << niz2[i] << " ";

    }
    return 0;
}